#!/usr/bin/python
#
# This file is a portion of the Red Hat Network Panel Applet
#
# Copyright (C) 1999-2002 Red Hat, Inc. All Rights Reserved.
# Distributed under GPL version 2.
#
# $Id: applet.py,v 1.11 2004/10/19 18:56:13 alikins Exp $

import sys
import os

sys.path.insert(0,"/usr/share/rhn/up2date_client")

import signal
import rhn_utils

# renice since it's only informative processing speed is not critical
try:
    os.nice(10)
except:
    pass;

# stupid gnome command line processor... gotta remove ours first
args = filter(lambda s: s != "-d", sys.argv)
if args != sys.argv:
    rhn_utils.set_log_level(5)
    sys.argv = args

import rhn_applet

def child_reaper(*args):
    try:
        while os.waitpid(-1, os.WNOHANG):
            pass
    except:
        pass

def main():
    signal.signal(signal.SIGINT, signal.SIG_DFL)
    signal.signal(signal.SIGCHLD, child_reaper)

    applet = rhn_applet.rhnApplet()
    applet.run()

if __name__ == "__main__":
    main()

